<?php
require_once("login.php");

$days = 1;  // if no backups within x days, create one
$keep = 5; // keep only x number of most recent backups

$backupfiles = array();
$backupfiles = glob("../content/backups/*");
rsort($backupfiles);

foreach ($backupfiles as $backupfile) {
	$backupcollection[] = $backupfile;	
}

if (count($backupcollection) > $keep) { 
    $i = 0;
    foreach ($backupcollection as $backup){	 
	    $i++;
	    if ($i > $keep) { 	 
	        if(file_exists($backup)){ 
	            unlink($backup);
	         } 	 
	     }	 
    }
}

$lastbackup = filemtime($backupcollection[0]) + ($days * 24 * 60 * 60);


if ($lastbackup > time()) { 	
	
	
} else { 

$today = date("m.d.y-gi");

$zip   = new ZipArchive();
 
$zip->open("../content/backups/" . $today . ".zip", ZipArchive::CREATE); 

//$dirNames = array('../content/pages','../content/blog','../content/media');

//include blocks and plug-ins
$dirNames = array('../content/blocks','../content/blog','../content/media','../content/pages','../inc/tags');

foreach ($dirNames as $dirName) {

    if (!is_dir($dirName)) { 
   	 echo $lang_backup_err_destination; 
   	 } 

   	 $dirName = realpath($dirName); 
    
    if (substr($dirName, -1) != '/') { 
	   	 $dirName.= '/'; 
	 } 
 
	 $dirStack = array($dirName); 

	 $cutFrom = strrpos(substr($dirName, 0, -1), '/')+1; 

	 while (!empty($dirStack)) { 
		 $currentDir = array_pop($dirStack); 
		 $filesToAdd = array(); 

		 $dir = dir($currentDir); 
     while (false !== ($node = $dir->read())) { 
          
          if (($node == '..') || ($node == '.')) { 
            continue; 
          } 
        
		  if (is_dir($currentDir . $node)) { 
            array_push($dirStack, $currentDir . $node . '/'); 
		  } 
        
          if (is_file($currentDir . $node)) { 
            $filesToAdd[] = $node; 
          } 
     } 

	 $localDir = substr($currentDir, $cutFrom); 
	 $zip->addEmptyDir($localDir); 
    
	 foreach ($filesToAdd as $file) { 
         $zip->addFile($currentDir . $file, $localDir . $file); 
     } 
   } 
  }
}
$zip->close(); //close the newly created zip archive


//	*********************************	Email settings	*********************************
$mailto		= "name@example.com";
$from_mail	= "server@example.co.uk";
$from_name	= "Example web server";
$replyto	= "noreply@example.co.uk";
$subject	= "Example server backup";
$message	= "Latest server backup attached.";


//	*********************************	Email the zip to the user	*********************************
//resort files and select the latest
$backupfiles = glob("../content/backups/*");
rsort($backupfiles);

//email the last zip archive
mail_attachment(basename($backupfiles[0]), dirname($backupfiles[0]), $mailto, $from_mail, $from_name, $replyto, $subject, $message);


//	*********************************	Common functions	*********************************

//email the zip to the admin
function mail_attachment($filename, $path, $mailto, $from_mail, $from_name, $replyto, $subject, $message){
	$realpath = realpath($path).'/';
	$file = $realpath.$filename;
	
	$file_size = filesize($file);
	
	$handle = fopen($file, "r");
	$content = fread($handle, $file_size);
	fclose($handle);
	$content = chunk_split(base64_encode($content));
	$uid = md5(uniqid(time()));
	$name = basename($file);
	
	// header
	$header = "From: ".$from_name." <".$from_mail.">\r\n";
	$header .= "Reply-To: ".$replyto."\r\n";
	$header .= "MIME-Version: 1.0\r\n";
	$header .= "Content-Type: multipart/mixed; boundary=\"".$uid."\"\r\n\r\n";
	
	// message & attachment
	$nmessage = "--".$uid."\r\n";
	$nmessage .= "Content-type:text/plain; charset=iso-8859-1\r\n";
	$nmessage .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
	$nmessage .= $message."\r\n\r\n";
	$nmessage .= "--".$uid."\r\n";
	$nmessage .= "Content-Type: application/octet-stream; name=\"".$filename."\"\r\n";
	$nmessage .= "Content-Transfer-Encoding: base64\r\n";
	$nmessage .= "Content-Disposition: attachment; filename=\"".$filename."\"\r\n\r\n";
	$nmessage .= $content."\r\n\r\n";
	$nmessage .= "--".$uid."--";
	
	if (mail($mailto, $subject, $nmessage, $header)) {
		return true;
	} else {
	  return false;
	}
}

?>